function [signal,case_signal]=generate_signal_lecture(time,rand1,rand2)
%%
%*************************************************************************
%*************************************************************************
% gerar diferentes tipos de sinal (transiente, peridico, etc)
if exist('rand1')~=1
    rand1=rand(1);
end

if exist('rand2')~=1
    rand2=rand(1);
end

if rand1 <= 0.2
    disp('Caso 1');
    case_signal=1;
    if rand2<=0.3333
        signal=sqrt(time);
    elseif rand2<=0.66666
        signal=exp(time);
    else
        signal=(time).^2+cos(time*5*rand(1));
    end
elseif rand1 <=0.4
    disp('Caso 2');
    case_signal=2;
    if rand2<=0.25
        signal=cos(2*round(6*rand(1)).*time)+sin(2*round(6*rand(1)).*time) ...
            +cos(2*round(6*rand(1)).*time+2*pi*rand(1));
        if rand(1)>=0.97
            ctrl_dirac=1
        else
            ctrl_dirac=0;
        end
        position=round(length(time).*rand);
        dirac_sig=10*double(isinf(dirac((1:length(time))-position)));
        signal=signal+dirac_sig.*ctrl_dirac;
        
    elseif rand2<=0.5
        signal=square(2*time*round(6*rand(1)))+square(2*time*round(6*rand(1)));
    elseif rand2<=0.75
        signal=sawtooth(2*time*round(6*rand(1)),0.5)+sawtooth(2*time*round(6*rand(1)),0.5);
    else
        signal=sawtooth(2*time*round(6*rand(1)),0.5)+cos(2*time*round(6*rand(1)));
    end
    
elseif rand1<=0.6
    disp('Caso 3');
    case_signal=3;
    if rand2<=0.33333333333333
        signal=rand(size(time));
    elseif rand2<=0.6666666666
        signal(1:length(time(:)))=0;
        for j=1:200
            signal=signal+cos(time*round(256*rand(1))+rand(1)*2*pi);
        end
        signal=signal(:)/j;
    else
        signal(1:length(time(:)))=0;
        for j=1:200
            signal=signal+sawtooth(time*round(256*rand(1))+rand(1)*2*pi,0.5)+rand(size(time));
        end
        signal=signal(:)/j;
    end
elseif rand1<=0.8
    disp('Caso 4');
    case_signal=4;
    if rand2<=0.333333
        signal=(rand(size(time))-0.5).*time/(2*pi).*cos(2*time)+...
            0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+rand(1);
    elseif rand2<=0.666666666
        signal=(rand(size(time))-0.5).*(1+cos(time*round(4*rand(1))+rand(1)*2*pi))+ ...
            0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+rand(1);
    else
        signal=(rand(size(time))-0.5).*(1+square(time*round(4*rand(1))+rand(1)*2*pi))+ ...
            0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+0.25*cos(time*round(100*rand(1))+rand(1)*2*pi)+rand(1);
    end
else
    disp('Caso 5');
    case_signal=5;
    if rand2<=0.3333
        signal=(rand(size(time))-0.5).*(square(time*round(4*rand(1)))+1)/2 ...
            .*(square(time*round(10*rand(1)))+1)/2;
    elseif rand2<=0.6666
        signal=(rand(size(time))-0.5).*(cos(time*round(4*rand(1)))+1)/2.*time/(2*pi) ...
            .*(square(time*round(10*rand(1)))+1)/2;
    else
        signal=(rand(size(time))-0.5).*(cos(time*round(8*rand(1)))+1)/2.*time/(2*pi) ...
            .*(sawtooth(time*round(12*rand(1)),rand(1))+1)/2;
    end
end
return